/*
 * Linker script for boot2nd
 * Most of it is strait forward, subtle points are:
 * - we include the .bss in the file image
 * - text address is 0x0
 * - we place the GOT (Global Offset Table) to be in the
 *   last PAGE, PAGE size aligned. At runtime we fixup the
 *   GOT based on our run address
 *
 * For some reason ASSERT is not working. A shame because I want
 * to assert SIZEOF(first_page_section) < 4096 and
 * SIZEOF(got_section) < 4096
 *
 */
OUTPUT_ARCH(arm)
ENTRY(_start)
SECTIONS
{
	. = 0x00000000;				/* link address is 0 for easy got fixup */
	.text : {					/* first page text section */
		entry.o(.text)
		boot2ndmain.o(.text)
		*(.text)
	}

	.text : {					/* remainging text section */
		*(.text)
	}

	. = ALIGN(4);
	.data : {					/* data and rodat section */
		*(.rodata)
		*(.data)
	}

	. = ALIGN(4);
	.data : {					/* include bss section */
		*(.bss)
		*(COMMON)
	}

		/*
		 * Put GOT (Global Offset Table) in the last PAGE, PAGE size
		 * aligned
		 */
	. = ALIGN(4096);
	. : {
		*(.got)
	}
}
